program experience;
uses crt, fmm;

const
  b     = 0.0;
  delta = 1.5;
  eps =  0.5;

var
  a : float;
  res: text;
{Vspomogatelnye funkcii}

{$F+}
function f1(x: float): float;
begin
  f1 := x - powrr(1.4, x);
end;

function f2(x:float): float;
begin
  f2 := (sin(x))/(sqr(x)+1);
end;

{$F-}

{Poisk A}
function aparam(f:pointer):float;
begin
  aparam := 0.5300355 * zeroin(0, 10, 1E-9, f);
end;

{Poisk epsilon}
function epsparam(f:pointer):float;
var
result, errest, flag: float;
nofun: longint;
begin
  quanc8(f, 0, 1, 1e-9, 1e-9, result, errest, nofun, flag);
  epsparam := 1.553791* result;
end;

{Vspomogatelnaya procedura}
{$F+}
procedure f3(t: float; var z, zp: floatvector);
begin
  zp[ 1] := z[ 2];
  zp[ 2] := -(delta + eps * cos( 2 * t)) * z[ 1];
end;
{$F-}

procedure ODESolve(f: pointer);
const neqn = 2;
var
  iflag            : integer;
  work                   : rvecn;
  iwork                  : ivec5;
  t, tout, relerr, abserr: float;
  y                      : floatvector;
begin
  t := 0; iflag := 1;
  y[1] := a; y[2] := b;
  relerr := 1e-6; abserr := 1e-6;
  tout := t;
  repeat
    rkf45(f, neqn, y, t, tout, relerr, abserr, iflag, work, iwork);
    case iflag of
      1, 8: break;
      2   : begin
              writeln(res{, tout:10:4}, y[1]:10:4{, y[2]:10:4, iflag:10});
              tout := tout + 0.5;
            end;
      5   : abserr := 1e-6;
      6   : begin
              relerr := 10 * relerr;
              iflag := 2;
            end;
      7   : iflag := 2;
    end;
  until tout > 20;
end;

begin
  clrscr;
  assign(res, 'res.txt');
  rewrite(res);
  a   := aparam( @f1);

  writeln(res, 'Parameters:');
  writeln(res, '   A       = ', a  :7:4);
  writeln(res, '   epsilon = ', eps:7:4); writeln;
  writeln(res, 'Solution of differencial equation'); writeln;
  writeln(res, '       t         U       dU/dt       iFlag'); writeln;
  ODESolve(@f3);
  close(res);
end.